#!/usr/bin/python
# -*- coding: latin-1 -*-
###
#
# This file is the legal property of Jean-Pierre Redonnet <redonnetbrouk@aol.com>
# Copyright (c) 2007 Jean-Pierre Redonnet
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import sys,os,string,math,random
from time import gmtime,strftime

### Chemical constants
element=[['C',12.01],
         ['H',1.00],
         ['O',16.00],
         ['N',14.00],
         ['S',32.06],
         ['P',30.97],
         ['B',10.81],
         ['I',126.90],
         ['F',18.99]]

nbelement= len(element)

### Variables
reactant=['','','',''] #4 reactants max
M_reactant=[0,0,0,0]
r_element=[]
for i in range(0,nbelement):r_element.append([0.0,0.0,0.0,0.0])

product=['','','',''] #4 products max
M_product=[0,0,0,0]
p_element=[]
for i in range(0,nbelement):p_element.append([0.0,0.0,0.0,0.0])

r_coef=[1,1,1,1] #4 reactants max
p_coef=[1,1,1,1] #4 products max

Nbreactant=0
Nbproduct=0

element_present= nbelement*[0] #92 elements

#none found
r_coef_fix=[0,0,0,0] #4 reactants max
p_coef_fix=[0,0,0,0] #4 products max

#version
version="0.2"
release="Exp"

def message(chaine):
    print chaine
    reponse=raw_input('Appuyez sur return!')
    exit(0)

#Count the same atom in a molecule, accept only integer
#no fractionnaire
def countatom(molecule,atom):
    n=''
    grp=1
    val_n=0
    braket=0
    i=len(molecule)-1
    while (i>=0):
        if (molecule[i]==atom):
            if (n==''): n='1'
            val_n+=grp*string.atoi(n)
            n=''
        else:
            if (molecule[i] in '0123456789'):
                n=molecule[i]+n
            else:
                if (molecule[i]==')'):
                    braket+=1
                    if braket>1: message('Err, imbricated )')
                    if (n==''): n='1'
                    grp=string.atoi(n)
                    n=''
                else:
                    if (molecule[i]=='('):
                        grp=1
                        braket-=1
                        if braket<0: message('Err, too many (')
                    else: n=''
        i=i-1
    if braket<>0: message('Err, nb of ( <> nb of )')
    return(val_n)


#simplify the equation, check element used only once in the left and right
def simplify():
    flag_r_element=nbelement*[0]  
    flag_p_element=nbelement*[0]
    
    for e in range(0,nbelement):
        for i in range(0,Nbreactant):
            if r_element[e][i]>0: flag_r_element[e]+=1
        for i in range(0,Nbproduct):
            if p_element[e][i]>0: flag_p_element[e]+=1

        #simplify the element if possible
        if (flag_r_element[e]*flag_p_element[e])==1:
            for i in range(0,Nbreactant):
                if r_element[e][i]>0:
                    for j in range(0,Nbproduct):
                        if p_element[e][j]>0:
                            r_coef[i]=p_element[e][j]
                            p_coef[j]=r_element[e][i]
                            r_coef_fix[i]=1
                            p_coef_fix[j]=1
            break
    return(0)


###simplify ppdc
def ppdc_coef():
    smallest=999999
    side='?'
    n=0
    ok=0
    for i in range(0,Nbreactant):
        if r_coef[i]==1:
            smallest=1
            side='L'
            break
        else:
            if (r_coef[i]<smallest) and (r_coef[i]>0): #the smallest but no 0
                smallest=r_coef[i]
                side='L'

    for i in range(0,Nbproduct):
        if p_coef[i]==1:
            smallest=1
            side='R'
            break
        else:
            if (p_coef[i]<smallest)  and (p_coef[i]>0):
                smallest=p_coef[i]
                side='R'
                
    while (ok==0):
        ok=1
        n+=1
        for i in range(0,Nbreactant):
            if (n*r_coef[i]%smallest)<>0: ok=0
        for i in range(0,Nbproduct):
            if (n*p_coef[i]%smallest)<>0: ok=0

    for i in range(0,Nbreactant):
        r_coef[i]=r_coef[i]*n/smallest
    for i in range(0,Nbproduct):
        p_coef[i]=p_coef[i]*n/smallest
            
    return(0)


### The Stupid Iterative Random Search Method
def search_coef(mini,maxi,maxloop):   
    boucle=0
    sous_boucle=0
    old_diff=999999
    total_coef=0
    old_r_coef=[0,0,0,0] #4 reactants max
    old_p_coef=[0,0,0,0]

    print 'Interative search can be long!!! Be patient! ',
    print 'Max loop:',maxloop

    while (boucle < maxloop):
        boucle+=1
        diff_element=nbelement*[0] #perhaps long
        diff=0
        for r in range(0,Nbreactant):
            if r_coef_fix[r]==0:
                r_coef[r]=random.randint(mini,maxi)
        for p in range(0,Nbproduct):
            if p_coef_fix[p]==0:
                p_coef[p]=random.randint(mini,maxi)

        for e in range(0,nbelement):
            if element_present[e]:
                for i in range(0,Nbreactant):
                    diff_element[e]+=r_element[e][i]*r_coef[i]
                for i in range(0,Nbproduct):
                    diff_element[e]-=p_element[e][i]*p_coef[i]
            diff+=abs(diff_element[e])

        if (diff<0.01):
            total=0
            for r in range(0,Nbreactant):total+=r_coef[r] #if all reactants are 0 do not break
            if total<>0: break
        
        if (diff<old_diff):
            old_diff=diff
            for r in range(0,Nbreactant):old_r_coef[r]=r_coef[r]
            for p in range(0,Nbproduct):old_p_coef[p]=p_coef[p]
            
    if boucle>=maxloop:
        for r in range(0,Nbreactant):r_coef[r]=old_r_coef[r]
        for p in range(0,Nbproduct):p_coef[p]=old_p_coef[p]
    
    return(diff)

#
# -------------program starts here !--------------------------
#
print 70*'-'
print "Equilibrium - JP Redonnet - ",release,"release - Ver.", version
print 70*'-'

print 'Nb element in base:',len(element)

choice='y'
while choice=='y':
    redo=1
    while redo:
        redo=0
        print '\n=> Be carefull with O (oxygen) and 0 (zero)'
        print '=> Only ',
        for e in range(0,nbelement): print element[e][0],
        print '\n=> No more than 4 reactants and 4 products\n'
        reponse=raw_input('Entrer only the reactants (separated with +):')
        reactants=string.replace(reponse,' ','')
        reponse=raw_input('Entrer only the products (separated with +):')
        products=string.replace(reponse,' ','')
        print 70*'-'
        print reactants+' -> '+products
        print 70*'-'

        Nbreactant=0
        for molecule in string.split(reactants,'+'):
            if Nbreactant>3: message('Error! No more than 4 reactants.')
            reactant[Nbreactant]=molecule
            for e in range(0,nbelement):
                r_element[e][Nbreactant]=countatom(molecule,element[e][0])
                M_reactant[Nbreactant]+= element[e][1]*r_element[e][Nbreactant]
            Nbreactant+=1

        Nbproduct=0
        for molecule in string.split(products,'+'):
            if Nbproduct>3: message('Error! No more than 4 products.')
            product[Nbproduct]=molecule
            for e in range(0,nbelement):
                p_element[e][Nbproduct]=countatom(molecule,element[e][0])
                M_product[Nbproduct]+= element[e][1]*p_element[e][Nbproduct]       
            Nbproduct+=1

        #calculate the nb total of each atom in the left member
        total_r_element = nbelement*[0]
        for i in range(0,Nbreactant):
            for e in range(0,nbelement):
                total_r_element[e]+=r_element[e][i]
                    
        #calculate the nb total of each atom in the left member
        total_p_element = nbelement*[0]
        for i in range(0,Nbproduct):
            for e in range(0,nbelement):
                total_p_element[e]+=p_element[e][i]
            
        print '\n',70*'-'
        for e in range(0,nbelement):
            if (total_r_element[e]+total_p_element[e])>0:
                print element[e][0],'\t',
        print ' '
        for e in range(0,nbelement):
            if (total_r_element[e]+total_p_element[e])>0:
                print total_r_element[e],'\t',
        print ' '
        for e in range(0,nbelement):
            if (total_r_element[e]+total_p_element[e])>0:
                print total_p_element[e],'\t',
        print ' '
        print 70*'-','\n'

        # Check for errors
        error=0
        for e in range(0,nbelement):
            if (total_r_element[e] > 0 and total_p_element[e] == 0):
                error+=1
                print 'Need '+element[e][0]+' on the right!'
                products+='+'+element[e][0]
            if (total_r_element[e] == 0 and total_p_element[e] > 0):
                error+=1
                print 'Need '+element[e][0]+' on the left!'
                reactants+='+'+element[e][0]

        if error>0:
            print 'The reaction could be ? : ',reactants+' -> '+products
            print(repr(error)+' errors! Check and correct the formulas.')
            redo=1

    #Elements in the reaction
    for e in range(0,nbelement):
        if total_r_element[e] > 0:
            element_present[e]=1
        else:
            element_present[e]=0

    redo=1
    while redo:
        redo=0
        #the user will try to balance the reaction
        reponse='n'
        while (reponse=='n'):
            # Enter the coefs of each moles
            print '\nNow you will enter the coef of each mole'
            for i in range(0,Nbreactant):
                print 'Reactant:',reactant[i],'\t: Enter the coef #',i+1,
                r_coef[i]=string.atof(raw_input(' '))
            for i in range(0,Nbproduct):
                print 'Product:',product[i],'\t: Enter the coef #',i+1,
                p_coef[i]=string.atof(raw_input(' '))
            # display and ask to confirm
            print 70*'-'
            for i in range(0,Nbreactant):
                print r_coef[i],reactant[i],
                if i<Nbreactant-1: print ' + ',
            print '->',
            for i in range(0,Nbproduct):
                print p_coef[i],product[i],
                if i<Nbproduct-1: print ' + ',
            print' '
            print 70*'-'
            print 'Do you agree with this?  ',
            reponse=''
            while reponse not in ['n','y']:
                reponse=raw_input('y/n?')

        print '\n',70*'-'
        # Now the program verify if the reaction is balanced!
        unbalanced=0
        total_r_element=nbelement*[0]
        total_p_element=nbelement*[0]

        for e in range(0,nbelement):
            #check for each element present
            if element_present[e]:
                for i in range(0,Nbreactant):
                    total_r_element[e]+=r_coef[i]*r_element[e][i]
                for i in range(0,Nbproduct):
                    total_p_element[e]+=p_coef[i]*p_element[e][i]
                if total_r_element[e]==total_p_element[e]:
                    print element[e][0],' is balanced'
                else:
                    print element[e][0],' is unbalanced!'
                    unbalanced=1
        if unbalanced:
            print 'Do you want to correct?  ',
            reponse=''
            while reponse not in ['n','y']:
                reponse=raw_input('y/n?')
            if reponse=='y': redo=1
    print 70*'-','\n'

#--- unbalanced reaction, will try to balance it
    if unbalanced:
        simplify() #search element only once in each member
        for i in range(0,Nbreactant):
            if (r_coef_fix[i]<>0):
                print 'Found: ',r_coef[i],reactant[i],
        for i in range(0,Nbproduct):
            if (p_coef_fix[i]<>0):
                print 'and: ',p_coef[i],product[i]
        print '\n'

            
        ###Search coefs with the interative random method
        # It's not the most clever and fastest method but it's easy!!!
        # maxi must be enough large to include all possibilities
        # maxloop must be big enough else the answer cannot be found
        # theorically, maxloop should be: (max-min)^nb coefs

        err=(search_coef(0,20,100000)) #coef value: mini,maxi,maxloop
        if err==0:
            print 'Coefs have been found :-)'
        else:
            print ':-( Unsolved! Sdy:',err
            for i in range(0,Nbreactant):
                if (r_coef_fix[i]<>0): 
                    r_coef[i]=r_coef[i]*2
                    err=-1
            for i in range(0,Nbproduct):
                if (p_coef_fix[i]<>0):
                    p_coef[i]=p_coef[i]*2
                    err=-1
            if err==-1:
                print 'Try # 2'
                err=(search_coef(0,30,100000)) #coef value: mini,maxi
                if err==0:
                    print 'Now coefs have been found :-)'
                else:
                    print ':-( Still unsolved! Sdy:',err
                    for i in range(0,Nbreactant):
                        if (r_coef_fix[i]<>0): 
                            r_coef[i]=r_coef[i]*3/2
                            err=-1
                    for i in range(0,Nbproduct):
                        if (p_coef_fix[i]<>0):
                            p_coef[i]=p_coef[i]*3/2
                            err=-1
                    if err==-1:
                        print 'Try # 3'
                        err=(search_coef(0,40,100000)) #coef value: mini,maxi
                        if err==0:
                            print 'Now coefs have been found :-)'
                        else:
                            print ':-( Still unsolved! Sdy:',err
                            for i in range(0,Nbreactant):
                                if (r_coef_fix[i]<>0): 
                                    r_coef[i]=r_coef[i]*5/3
                                    err=-1
                            for i in range(0,Nbproduct):
                                if (p_coef_fix[i]<>0):
                                    p_coef[i]=p_coef[i]*5/3
                                    err=-1
                            if err==-1:
                                print 'Try # 4'
                                err=(search_coef(0,50,100000)) #coef value: mini,maxi
                                if err==0:
                                    print 'Now coefs have been found :-)'
                                else:
                                    print ':-( Still unsolved! Sdy:',err
                                    for i in range(0,Nbreactant):
                                        if (r_coef_fix[i]<>0): 
                                            r_coef[i]=r_coef[i]*7/5
                                            err=-1
                                    for i in range(0,Nbproduct):
                                        if (p_coef_fix[i]<>0):
                                            p_coef[i]=p_coef[i]*7/5
                                            err=-1
                                    if err==-1:
                                        print 'Try #5'
                                        err=(search_coef(0,60,100000)) #coef value: mini,maxi
                                        if err==0:
                                            print 'Now coefs have been found :-)'
                                        else:
                                            print ':-( Still unsolved! Sdy:',err
                                            for i in range(0,Nbreactant):
                                                if (r_coef_fix[i]<>0): 
                                                    r_coef[i]=r_coef[i]*11/7
                                                    err=-1
                                            for i in range(0,Nbproduct):
                                                if (p_coef_fix[i]<>0):
                                                    p_coef[i]=p_coef[i]*11/7
                                                    err=-1
                                            if err==-1:
                                                print 'Last try!'
                                                err=(search_coef(0,70,100000)) #coef value: mini,maxi
                                                if err==0:
                                                    print 'Now coefs have been found :-)'
                                                else:
                                                    print ':-( I really unable to solve it! Sdy:',err

        if err>0: message("Sorry! :-(")
    else:
        print 'Good job! The reaction is correctly balanced :-)'
    #----------------------------------------------------------

    ppdc_coef() #simplify coef

    # Show the balanced reaction
    print '\n',70*'-'
    print ' The answer is:'
    for i in range(0,Nbreactant):
        print r_coef[i],reactant[i],
        if i<Nbreactant-1: print ' + ',
    print ' -> ',
    for i in range(0,Nbproduct):
        print p_coef[i],product[i],
        if i<Nbproduct-1: print ' + ',
    print ' '

    for i in range(0,Nbreactant): print ' M=',M_reactant[i],'g  ',
    print '  ',
    for i in range(0,Nbproduct): print ' M=',M_product[i],'g  ',
    print ' '
    for i in range(0,Nbreactant): print ' n=',r_coef[i],'  ',
    print '  ',
    for i in range(0,Nbproduct): print ' n=',p_coef[i],'  ',
    print ' '
    for i in range(0,Nbreactant): print ' m=',M_reactant[i]*r_coef[i],'g  ',
    print '  ',
    for i in range(0,Nbproduct): print ' m=',M_product[i]*p_coef[i],'g  ',
    print '\n',70*'-','\n'

    #quit or again
    choice=''
    while choice not in ['n','y']:
        choice=raw_input('An other one? (y/n?)')

message("\n=> The work is done! Hope, it's good! :-)")
#------------------- End !---------------------

### COMMENTS:
#
# JP Redonnet - Philadelphia


### INFO ABOUT THE PROGRAM
# 
# 

### INFO ABOUT  DATA
# Only 4 reactants and 4 products 
# 


### HISTORY:
#
# October 8 2007 => ver 0.2 released
# This program balances chemical reactions

### Pb to solve
#
# Check if the reaction cannot be balanced
# Tabulate results correctly
# Solver doesn't work very well => try Gauss-Jordan elimination or Matrix calculation


### IMPROVEMENT:
#
# There are plenty of improvement to do! Make it accept:
# Symbol of 2 chars: Ca, Mg, Mn, Fe, Cu, Cl, Br ...
# Ions: Ca2+, CHCO3- ...


### HOW TO USE IT:
#
# Install this program in an executable directory (in your home folder should be ok)
# Run it from the console

### ANY COMMENT:
#
# send me your comment here: http://sansmicrosoft.blogspot.com/
#
